function init()
  data.active = false
  data.timer = 0
  tech.setVisible(false)
  data.holdingUp = false
  data.holdingDown = false
  data.left = false
  data.right = false
  data.jump = false
end

function uninit()
  if data.active then
    tech.setParentOffset({0, 0})
    data.active = false
    tech.setVisible(false)
    tech.setParentAppearance("normal")
    tech.setToolUsageSuppressed(false)
    tech.setParentFacingDirection(nil)
  end
end

function input(args)
  
  if args.moves["up"] then
    data.holdingUp = true
  elseif not args.moves["up"] then
    data.holdingUp = false
  end
  
  if args.moves["down"] then
    data.holdingDown = true
  elseif not args.moves["down"] then
    data.holdingDown = false
  end
  
  if args.moves["left"] then
    data.left = true
  else
    data.left = false
  end
  
  if args.moves["right"] then
    data.right = true
  else
    data.right = false
  end

  if args.moves["special"] == 1 then
    if data.active then
      return "swimDeactivate"
    else
      return "swimActivate"
    end
 end

  return nil
end
function update(args)
  -- get parameters from dbzswim.tech
  local swimCustomMovementParameters = tech.parameter("swimCustomMovementParameters")
  local parentOffset = tech.parameter("parentOffset")
  local swimCollisionTest = tech.parameter("swimCollisionTest")
  local energyCostPerSecond = tech.parameter("energyCostPerSecond")
  -- activate mech
  if not data.active and args.actions["swimActivate"] then
    -- check for collision
    swimCollisionTest[1] = swimCollisionTest[1] + tech.position()[1]
    swimCollisionTest[2] = swimCollisionTest[2] + tech.position()[2]
    swimCollisionTest[3] = swimCollisionTest[3] + tech.position()[1]
    swimCollisionTest[4] = swimCollisionTest[4] + tech.position()[2]
    if not world.rectCollision(swimCollisionTest) and tech.inLiquid() then
      tech.setVisible(true)
      tech.setParentAppearance("normal")
      tech.setToolUsageSuppressed(false)
      tech.setParentOffset(parentOffset)
      data.active = true
	  tech.burstParticleEmitter("swimstart")
    else
      -- Make some kind of error noise
    end
  end
	
  --deactivate mech
  if data.active and (args.actions["swimDeactivate"] or energyCostPerSecond * args.dt > args.availableEnergy or not tech.inLiquid())  then
    tech.setVisible(false)
    tech.setParentAppearance("normal")
    tech.setToolUsageSuppressed(false)
    tech.setParentOffset({0, 0})
    data.active = false
  end
	
  if data.active then
	
	if not tech.onGround() then
		tech.applyMovementParameters(swimCustomMovementParameters)
		if data.holdingUp and data.right then
			tech.yControl(tech.parameter("swimSpeed"), 1000, true)
			tech.xControl(tech.parameter("swimSpeed"), 1000, true)
			tech.setParentAppearance("fly")
		elseif data.holdingUp and data.left then
			tech.yControl(tech.parameter("swimSpeed"), 1000, true)
			tech.xControl(-tech.parameter("swimSpeed"), 1000, true)
			tech.setParentAppearance("fly")
		elseif data.holdingDown and data.right then
			tech.yControl(-tech.parameter("swimSpeed"), 1000, true)
			tech.xControl(tech.parameter("swimSpeed"), 1000, true)
			tech.setParentAppearance("fall")
		elseif data.holdingDown and data.left then
			tech.yControl(-tech.parameter("swimSpeed"), 1000, true)
			tech.xControl(-tech.parameter("swimSpeed"), 1000, true)
			tech.setParentAppearance("fall")
		elseif data.holdingDown then
			tech.yControl(-tech.parameter("swimSpeed"), 1000, true)
			tech.setParentAppearance("fall")
		elseif data.holdingUp then
			tech.yControl(tech.parameter("swimSpeed"), 1000, true)
			tech.setParentAppearance("fly")
		elseif data.right then
			tech.xControl(tech.parameter("swimSpeed"), 1000, true)
		elseif data.left then
			tech.xControl(-tech.parameter("swimSpeed"), 1000, true)
		else
			tech.setParentAppearance("normal")
		end
	else
		tech.setParentAppearance("normal")
	end
  return energyCostPerSecond * args.dt
  end
  
  return 0
end